VirtualBox

source: vbox/trunk/src/VBox/Additions/linux/installer/vboxadd.sh@ 37084

Last change on this file since 37084 was 36948, checked in by vboxsync, 14 years ago

Additions/linux/installer: make sure gcc and make are installed too

  • Property svn:eol-style set to LF
  • Property svn:keywords set to Author Date Id Revision
File size: 14.1 KB
Line 
1#! /bin/sh
2#
3# Linux Additions kernel module init script ($Revision: 36948 $)
4#
5
6#
7# Copyright (C) 2006-2010 Oracle Corporation
8#
9# This file is part of VirtualBox Open Source Edition (OSE), as
10# available from http://www.virtualbox.org. This file is free software;
11# you can redistribute it and/or modify it under the terms of the GNU
12# General Public License (GPL) as published by the Free Software
13# Foundation, in version 2 as it comes in the "COPYING" file of the
14# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
15# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
16#
17
18
19# chkconfig: 357 30 70
20# description: VirtualBox Linux Additions kernel modules
21#
22### BEGIN INIT INFO
23# Provides: vboxadd
24# Required-Start:
25# Required-Stop:
26# Default-Start: 2 3 4 5
27# Default-Stop: 0 1 6
28# Description: VirtualBox Linux Additions kernel modules
29### END INIT INFO
30
31PATH=$PATH:/bin:/sbin:/usr/sbin
32PACKAGE=VBoxGuestAdditions
33BUILDVBOXGUEST=`/bin/ls /usr/src/vboxguest*/vboxguest/build_in_tmp 2>/dev/null|cut -d' ' -f1`
34BUILDVBOXSF=`/bin/ls /usr/src/vboxguest*/vboxsf/build_in_tmp 2>/dev/null|cut -d' ' -f1`
35BUILDVBOXVIDEO=`/bin/ls /usr/src/vboxguest*/vboxvideo/build_in_tmp 2>/dev/null|cut -d' ' -f1`
36DODKMS=`/bin/ls /usr/src/vboxguest*/do_dkms 2>/dev/null|cut -d' ' -f1`
37LOG="/var/log/vboxadd-install.log"
38MODPROBE=/sbin/modprobe
39
40if $MODPROBE -c | grep -q '^allow_unsupported_modules *0'; then
41 MODPROBE="$MODPROBE --allow-unsupported-modules"
42fi
43
44# Check architecture
45cpu=`uname -m`;
46case "$cpu" in
47 i[3456789]86|x86)
48 cpu="x86"
49 lib_path="/usr/lib"
50 ;;
51 x86_64|amd64)
52 cpu="amd64"
53 if test -d "/usr/lib64"; then
54 lib_path="/usr/lib64"
55 else
56 lib_path="/usr/lib"
57 fi
58 ;;
59esac
60
61if [ -f /etc/arch-release ]; then
62 system=arch
63elif [ -f /etc/redhat-release ]; then
64 system=redhat
65elif [ -f /etc/SuSE-release ]; then
66 system=suse
67elif [ -f /etc/gentoo-release ]; then
68 system=gentoo
69elif [ -f /etc/lfs-release -a -d /etc/rc.d/init.d ]; then
70 system=lfs
71else
72 system=other
73fi
74
75if [ "$system" = "arch" ]; then
76 USECOLOR=yes
77 . /etc/rc.d/functions
78 fail_msg() {
79 stat_fail
80 }
81
82 succ_msg() {
83 stat_done
84 }
85
86 begin() {
87 stat_busy "$1"
88 }
89fi
90
91if [ "$system" = "redhat" ]; then
92 . /etc/init.d/functions
93 fail_msg() {
94 echo_failure
95 echo
96 }
97 succ_msg() {
98 echo_success
99 echo
100 }
101 begin() {
102 echo -n "$1"
103 }
104fi
105
106if [ "$system" = "suse" ]; then
107 . /etc/rc.status
108 fail_msg() {
109 rc_failed 1
110 rc_status -v
111 }
112 succ_msg() {
113 rc_reset
114 rc_status -v
115 }
116 begin() {
117 echo -n "$1"
118 }
119fi
120
121if [ "$system" = "gentoo" ]; then
122 if [ -f /sbin/functions.sh ]; then
123 . /sbin/functions.sh
124 elif [ -f /etc/init.d/functions.sh ]; then
125 . /etc/init.d/functions.sh
126 fi
127 fail_msg() {
128 eend 1
129 }
130 succ_msg() {
131 eend $?
132 }
133 begin() {
134 ebegin $1
135 }
136 if [ "`which $0`" = "/sbin/rc" ]; then
137 shift
138 fi
139fi
140
141if [ "$system" = "lfs" ]; then
142 . /etc/rc.d/init.d/functions
143 fail_msg() {
144 echo_failure
145 }
146 succ_msg() {
147 echo_ok
148 }
149 begin() {
150 echo $1
151 }
152fi
153
154if [ "$system" = "other" ]; then
155 fail_msg() {
156 echo " ...fail!"
157 }
158 succ_msg() {
159 echo " ...done."
160 }
161 begin() {
162 echo -n $1
163 }
164fi
165
166dev=/dev/vboxguest
167userdev=/dev/vboxuser
168owner=vboxadd
169group=1
170
171test_for_gcc_and_make()
172{
173 which make > /dev/null 2>&1 || printf "\nThe make utility was not found. If the following module compilation fails then\nthis could be the reason and you should try installing it.\n"
174 which gcc > /dev/null 2>&1 || printf "\nThe gcc utility was not found. If the following module compilation fails then\nthis could be the reason and you should try installing it.\n"
175}
176
177test_sane_kernel_dir()
178{
179 KERN_VER=`uname -r`
180 KERN_DIR="/lib/modules/$KERN_VER/build"
181 if [ -d "$KERN_DIR" ]; then
182 KERN_REL=`make -sC $KERN_DIR --no-print-directory kernelrelease 2>/dev/null || true`
183 if [ -z "$KERN_REL" -o "x$KERN_REL" = "x$KERN_VER" ]; then
184 return 0
185 fi
186 fi
187 printf "\nThe headers for the current running kernel were not found. If the following\nmodule compilation fails then this could be the reason.\n"
188 if [ "$system" = "redhat" ]; then
189 printf "The missing package can be probably installed with\nyum install kernel-devel-$KERN_VER\n"
190 elif [ "$system" = "suse" ]; then
191 KERN_VER_SUSE=`echo "$KERN_VER" | sed 's/.*-\([^-]*\)/\1/g'`
192 KERN_VER_BASE=`echo "$KERN_VER" | sed 's/\(.*\)-[^-]*/\1/g'`
193 printf "The missing package can be probably installed with\nzypper install kernel-$KERN_VER_SUSE-devel-$KERN_VER_BASE\n"
194 elif [ "$system" = "debian" ]; then
195 printf "The missing package can be probably installed with\napt-get install linux-headers-$KERN_VER\n"
196 fi
197}
198
199fail()
200{
201 if [ "$system" = "gentoo" ]; then
202 eerror $1
203 exit 1
204 fi
205 fail_msg
206 echo "($1)"
207 exit 1
208}
209
210running_vboxguest()
211{
212 lsmod | grep -q "vboxguest[^_-]"
213}
214
215running_vboxadd()
216{
217 lsmod | grep -q "vboxadd[^_-]"
218}
219
220running_vboxsf()
221{
222 lsmod | grep -q "vboxsf[^_-]"
223}
224
225do_vboxguest_non_udev()
226{
227 if [ ! -c $dev ]; then
228 maj=`sed -n 's;\([0-9]\+\) vboxguest;\1;p' /proc/devices`
229 if [ ! -z "$maj" ]; then
230 min=0
231 else
232 min=`sed -n 's;\([0-9]\+\) vboxguest;\1;p' /proc/misc`
233 if [ ! -z "$min" ]; then
234 maj=10
235 fi
236 fi
237 test -z "$maj" && {
238 rmmod vboxguest 2>/dev/null
239 fail "Cannot locate the VirtualBox device"
240 }
241
242 mknod -m 0664 $dev c $maj $min || {
243 rmmod vboxguest 2>/dev/null
244 fail "Cannot create device $dev with major $maj and minor $min"
245 }
246 fi
247 chown $owner:$group $dev 2>/dev/null || {
248 rm -f $dev 2>/dev/null
249 rm -f $userdev 2>/dev/null
250 rmmod vboxguest 2>/dev/null
251 fail "Cannot change owner $owner:$group for device $dev"
252 }
253
254 if [ ! -c $userdev ]; then
255 maj=10
256 min=`sed -n 's;\([0-9]\+\) vboxuser;\1;p' /proc/misc`
257 if [ ! -z "$min" ]; then
258 mknod -m 0666 $userdev c $maj $min || {
259 rm -f $dev 2>/dev/null
260 rmmod vboxguest 2>/dev/null
261 fail "Cannot create device $userdev with major $maj and minor $min"
262 }
263 chown $owner:$group $userdev 2>/dev/null || {
264 rm -f $dev 2>/dev/null
265 rm -f $userdev 2>/dev/null
266 rmmod vboxguest 2>/dev/null
267 fail "Cannot change owner $owner:$group for device $userdev"
268 }
269 fi
270 fi
271}
272
273start()
274{
275 begin "Starting the VirtualBox Guest Additions ";
276 which udevd >/dev/null 2>&1 || no_udev=1
277 running_vboxguest || {
278 rm -f $dev || {
279 fail "Cannot remove $dev"
280 }
281
282 rm -f $userdev || {
283 fail "Cannot remove $userdev"
284 }
285
286 $MODPROBE vboxguest >/dev/null 2>&1 || {
287 fail "modprobe vboxguest failed"
288 }
289 case "$no_udev" in 1)
290 sleep .5;;
291 esac
292 }
293 case "$no_udev" in 1)
294 do_vboxguest_non_udev;;
295 esac
296
297 if [ -n "$BUILDVBOXSF" ]; then
298 running_vboxsf || {
299 $MODPROBE vboxsf > /dev/null 2>&1 || {
300 if dmesg | grep "vboxConnect failed" > /dev/null 2>&1; then
301 fail_msg
302 echo "Unable to start shared folders support. Make sure that your VirtualBox build"
303 echo "supports this feature."
304 exit 1
305 fi
306 fail "modprobe vboxsf failed"
307 }
308 }
309 fi
310
311 # Mount all shared folders from /etc/fstab. Normally this is done by some
312 # other startup script but this requires the vboxdrv kernel module loaded.
313 # This isn't necessary anymore as the vboxsf module is autoloaded.
314 # mount -a -t vboxsf
315
316 succ_msg
317 return 0
318}
319
320stop()
321{
322 begin "Stopping VirtualBox Additions ";
323 if ! umount -a -t vboxsf 2>/dev/null; then
324 fail "Cannot unmount vboxsf folders"
325 fi
326 if [ -n "$BUILDVBOXSF" ]; then
327 if running_vboxsf; then
328 rmmod vboxsf 2>/dev/null || fail "Cannot unload module vboxsf"
329 fi
330 fi
331 if running_vboxguest; then
332 rmmod vboxguest 2>/dev/null || fail "Cannot unload module vboxguest"
333 rm -f $userdev || fail "Cannot unlink $userdev"
334 rm -f $dev || fail "Cannot unlink $dev"
335 fi
336 succ_msg
337 return 0
338}
339
340restart()
341{
342 stop && start
343 return 0
344}
345
346# Remove any existing VirtualBox guest kernel modules from the disk, but not
347# from the kernel as they may still be in use
348cleanup_modules()
349{
350 begin "Removing existing VirtualBox DKMS kernel modules"
351 $DODKMS uninstall > $LOG
352 succ_msg
353 begin "Removing existing VirtualBox non-DKMS kernel modules"
354 find /lib/modules -name vboxadd\* | xargs rm 2>/dev/null
355 find /lib/modules -name vboxguest\* | xargs rm 2>/dev/null
356 find /lib/modules -name vboxvfs\* | xargs rm 2>/dev/null
357 find /lib/modules -name vboxsf\* | xargs rm 2>/dev/null
358 find /lib/modules -name vboxvideo\* | xargs rm 2>/dev/null
359 succ_msg
360}
361
362# Build and install the VirtualBox guest kernel modules
363setup_modules()
364{
365 # don't stop the old modules here -- they might be in use
366 cleanup_modules
367 begin "Building the VirtualBox Guest Additions kernel modules"
368
369 # Short cut out if a dkms build succeeds
370 if $DODKMS install >> $LOG 2>&1; then
371 succ_msg
372 return 0
373 fi
374
375 test_for_gcc_and_make
376 test_sane_kernel_dir
377
378 echo
379 if expr `uname -r` '<' '2.6.27' > /dev/null; then
380 echo "Not building the VirtualBox advanced graphics driver as this Linux version is"
381 echo "too old to use it."
382 BUILDVBOXVIDEO=
383 fi
384 if [ -n "$BUILDVBOXGUEST" ]; then
385 begin "Building the main Guest Additions module"
386 if ! $BUILDVBOXGUEST \
387 --save-module-symvers /tmp/vboxguest-Module.symvers \
388 --no-print-directory install >> $LOG 2>&1; then
389 fail "Look at $LOG to find out what went wrong"
390 fi
391 succ_msg
392 fi
393 if [ -n "$BUILDVBOXSF" ]; then
394 begin "Building the shared folder support module"
395 if ! $BUILDVBOXSF \
396 --use-module-symvers /tmp/vboxguest-Module.symvers \
397 --no-print-directory install >> $LOG 2>&1; then
398 fail "Look at $LOG to find out what went wrong"
399 fi
400 succ_msg
401 fi
402 if [ -n "$BUILDVBOXVIDEO" ]; then
403 begin "Building the OpenGL support module"
404 if ! $BUILDVBOXVIDEO \
405 --use-module-symvers /tmp/vboxguest-Module.symvers \
406 --no-print-directory install >> $LOG 2>&1; then
407 fail "Look at $LOG to find out what went wrong"
408 fi
409 succ_msg
410 fi
411 depmod
412 return 0
413}
414
415# Do non-kernel bits needed for the kernel modules to work properly (user
416# creation, udev, mount helper...)
417extra_setup()
418{
419 begin "Doing non-kernel setup of the Guest Additions"
420 echo "Creating user for the Guest Additions." >> $LOG
421 # This is the LSB version of useradd and should work on recent
422 # distributions
423 useradd -d /var/run/vboxadd -g 1 -r -s /bin/false vboxadd >/dev/null 2>&1
424 # And for the others, we choose a UID ourselves
425 useradd -d /var/run/vboxadd -g 1 -u 501 -o -s /bin/false vboxadd >/dev/null 2>&1
426
427 # Add a group "vboxsf" for Shared Folders access
428 # All users which want to access the auto-mounted Shared Folders have to
429 # be added to this group.
430 groupadd -f vboxsf >/dev/null 2>&1
431
432 # Create udev description file
433 if [ -d /etc/udev/rules.d ]; then
434 echo "Creating udev rule for the Guest Additions kernel module." >> $LOG
435 udev_call=""
436 udev_app=`which udevadm 2> /dev/null`
437 if [ $? -eq 0 ]; then
438 udev_call="${udev_app} version 2> /dev/null"
439 else
440 udev_app=`which udevinfo 2> /dev/null`
441 if [ $? -eq 0 ]; then
442 udev_call="${udev_app} -V 2> /dev/null"
443 fi
444 fi
445 udev_fix="="
446 if [ "${udev_call}" != "" ]; then
447 udev_out=`${udev_call}`
448 udev_ver=`expr "$udev_out" : '[^0-9]*\([0-9]*\)'`
449 if [ "$udev_ver" = "" -o "$udev_ver" -lt 55 ]; then
450 udev_fix=""
451 fi
452 fi
453 ## @todo 60-vboxadd.rules -> 60-vboxguest.rules ?
454 echo "KERNEL=${udev_fix}\"vboxguest\", NAME=\"vboxguest\", OWNER=\"vboxadd\", MODE=\"0660\"" > /etc/udev/rules.d/60-vboxadd.rules
455 echo "KERNEL=${udev_fix}\"vboxuser\", NAME=\"vboxuser\", OWNER=\"vboxadd\", MODE=\"0666\"" >> /etc/udev/rules.d/60-vboxadd.rules
456 fi
457
458 # Put mount.vboxsf in the right place
459 ln -sf "$lib_path/$PACKAGE/mount.vboxsf" /sbin
460 # At least Fedora 11 and Fedora 12 demand on the correct security context when
461 # executing this command from service scripts. Shouldn't hurt for other distributions.
462 chcon -u system_u -t mount_exec_t "$lib_path/$PACKAGE/mount.vboxsf" > /dev/null 2>&1
463
464 succ_msg
465}
466
467# setup_script
468setup()
469{
470 setup_modules
471 mod_succ="$?"
472 extra_setup
473 if [ "$mod_succ" -eq "0" ]; then
474 if running_vboxguest || running_vboxadd; then
475 printf "You should restart your guest to make sure the new modules are actually used\n\n"
476 else
477 start
478 fi
479 fi
480}
481
482# cleanup_script
483cleanup()
484{
485 # Delete old versions of VBox modules.
486 cleanup_modules
487 depmod
488
489 # Remove old module sources
490 rm -rf /usr/src/vboxadd-* /usr/src/vboxguest-* /usr/src/vboxvfs-* /usr/src/vboxsf-* /usr/src/vboxvideo-*
491
492 # Remove other files
493 rm /sbin/mount.vboxsf 2>/dev/null
494 rm /etc/udev/rules.d/60-vboxadd.rules 2>/dev/null
495}
496
497dmnstatus()
498{
499 if running_vboxguest; then
500 echo "The VirtualBox Additions are currently running."
501 else
502 echo "The VirtualBox Additions are not currently running."
503 fi
504}
505
506case "$1" in
507start)
508 start
509 ;;
510stop)
511 stop
512 ;;
513restart)
514 restart
515 ;;
516setup)
517 setup
518 ;;
519cleanup)
520 cleanup
521 ;;
522status)
523 dmnstatus
524 ;;
525*)
526 echo "Usage: $0 {start|stop|restart|status|setup}"
527 exit 1
528esac
529
530exit
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette